#ifndef _DOOR_H
#define _DOOR_H

#include "world_entity.h"


class TiXmlElement;


class Door : public WorldEntity
{
  public:
    Door ();
    Door(const TiXmlElement* root);
    virtual ~Door ();

    void init();
    virtual void loadParams(const TiXmlElement* root);

    void setActionRadius(float radius) { this->actionRadius = radius; }

    virtual void tick (float time);

    void open();
    void close();

    void lock() { this->bLocked = true; }
    void unlock() { this->bLocked = false; }
    bool isLocked() const { return this->bLocked; }


  private:
    bool checkOpen();
    void setAnimation(int animationIndex, int animPlaybackMode);


  private:
    bool           bOpen;             //!< true if the door is open
    bool           bLocked;           //!< true if this door is locked
    float          actionRadius;      //!< action radius


};

#endif /* _DOOR_H */
